﻿
function colision(pipaA, pipaB){

	if(!pipaB.morreu){
		if(pipaA.morreu) {
			if(pipaA.fatiou == -1){
				if(pipaB.scale < pipaA.scale) rabiolaColidiu(pipaB, pipaA);
			}
		}
	}

	if(!pipaA.morreu){

		var xA = pipaA.groupX,
		yA = pipaA.groupY,
		wA = 1,
		hA = 1,
		result = null,
		xB = pipaB.groupX,
		yB = pipaB.groupY,
		wB = 1,
		hB = 1,
		podeAparar = false;

		//========== POINT +			

		pipaA.scalePoint = 0;
		pipaB.scalePoint = 0;

		if(pipaA.scale < pipaB.scale){
			pipaA.scalePoint = Math.abs(pipaA.scale - pipaB.scale) * 2;
			xA = pipaA.getPointX();
			yA = pipaA.getPointY();
			podeAparar = true;
			//=== COLISÃO RABIOLA
			if(pipaB.morreu) {
				if(pipaB.fatiou == -1) rabiolaColidiu(pipaA, pipaB);
			}
			
		}else{
			pipaB.scalePoint = Math.abs(pipaA.scale - pipaB.scale) * 2;
			xB = pipaB.getPointX();
			yB = pipaB.getPointY();
		}


		if(pipaB.timeCorte < 70 || pipaA.timeCorte < 70) return;
		
		if(!pipaB.morreu){

			//line colision
			result = checkLineIntersection(
				pipaA.posLine.x, pipaA.posLine.y, xA, yA,
				pipaB.posLine.x, pipaB.posLine.y, xB, yB
			);

			if(result.onLine1 && result.onLine2){

				
//======================================================================================
				//CÁLCULO CORTE ===========================

				var rand1 = 0,
				rand2 = 0,
				pipaPrincipalDibicando = TweenMax.isTweening( pipaA.pipa ),
				pipaInimigoDibicando = TweenMax.isTweening( pipaB.pipa );

				if(pipaPrincipalDibicando) rand1 += parseFloat(pipaA.poderLine.split('/')[2]);
				if(pipaInimigoDibicando) rand2 += parseFloat(pipaB.poderLine.split('/')[2]);
				if(pipaA.gravidade < 0) rand1 += parseFloat(pipaA.poderLine.split('/')[0]) + (-1.66 * pipaA.gravidade);//acres velocidade descarregar
				if(pipaB.gravidade < 0) rand2 += parseFloat(pipaB.poderLine.split('/')[0]) + (-1.66 * pipaB.gravidade);//acres velocidade descarregar

				//console.log(pipaA.gravidade, pipaB.gravidade)
				
				if(pipaA.gravidade > 0) {
					//Puxando de baixo p/ cima maior chance de corte
					var rot = pipaA.pipa.getRotation() + 135;
					rand1 += (rot > -70 && rot < 70) ? parseFloat(pipaA.poderLine.split('/')[1]) : parseFloat(pipaA.poderLine.split('/')[1]) / 1.3;
					rand1 += (pipaA.gravidade / 4);//acres velocidade puxão
				}
				if(pipaB.gravidade > 0) {
					//Puxando de baixo p/ cima maior chance de corte
					var rot = pipaB.pipa.getRotation() + 135;
					rand2 += (rot > -70 && rot < 70) ? parseFloat(pipaB.poderLine.split('/')[1]) : parseFloat(pipaB.poderLine.split('/')[1]) / 1.3;
					rand2 += (pipaB.gravidade / 4);//acres velocidade puxão
				}

				if(type != 'online') rand1 += 0.5;

				//PIPA Mais distante pontua
				(podeAparar) ? rand1 += 0.13 : rand2 += 0.13;

				//FIM - CÁLCULO CORTE ===========================

				if(type == 'online'){
					//pipaA.pararCortou = true;
					var f = (rand(rand1, -(rand2)) > 0) ? {voou:pipaB.name, cortou:pipaA.name, x:Number(result.x.toFixed(2)), y:Number(result.y.toFixed(2))} : {voou:pipaA.name, cortou:pipaB.name, x:Number(result.x.toFixed(2)), y:Number(result.y.toFixed(2))};
					socket.emit('voou', f);
					return;
				}


//======================================================================================				


			//rand1 += 140;//


			if( rand(rand1, -(rand2)) > 0 ){
					
					//pipaB.setMorreu();
					pipaB.setMorreu(pipaA, result.x, result.y);
					
					if(pipaA.pipaPrincipal){
						
						var dif = pipaB.linha.getPoints()[3],
						a1 = pipaB.linha.getPoints()[1] - dif,
						a3 = result.y - dif;
						
						//cheio de linha
						if(1 - ((a3 / a1) * 1) < 0.2 && Math.random() < 0.4){//nao repetir mto nodededo 0.4
							playSom('nodedo1');
						}else{
							sons.play('cortou');
						}


						if(type == "festival") {
							$('#placar .it').eq(0).find('figure').html( parseInt($('#placar .it').eq(0).find('figure').html()) + 1 );
							Storage.updateRecordFestival();
							if(Math.random() < 0.2) insertPipaFestival(pipas.length);
						}

						if(type == 'combate'){

							if(indiceFase == jsonPipas.length-1 && !cortouTodas){
								
								cortouTodas = true;

								/*
								$('body').append(
								'<div id="popup" class="animated zoomInDown">' +
					            '    <div class="tx">' +
					            '        <a class="close"></a>' +
					            '        <h1>' + getHashtag('cortoutodas') + '</h1>' +
					            '    </div>' +
					            '</div>');
					            $('#popup .close').tap(function(){$('#popup').remove();});
					            */

					            setBalaoCortouTodas();
								
							}
						}



					}
				}else{

					if(pipaA.pipaPrincipal) clearTimeout(timeoutDelaySom);
					if(pipaA.pipaPrincipal) sons.play('voou');
					pipaA.setMorreu(pipaB, result.x, result.y);

				}

				if(pipaA.pipaPrincipal) setVibrate();

			}


		}

	

	}

}

function rabiolaColidiu(pipaA, pipaB){

	if(pipaB.totFitasRabiola > 2 || pipaB.totFitasRabiola == 1){

		if(pipaB.rabiolaColidiu == null){

			var result2 = {onLine1:true,onLine2:true}

			if(pipaB.totFitasRabiola != 1){
				result2 = checkLineIntersection(
					pipaA.posLine.x, pipaA.posLine.y, pipaA.linha.getPoints()[2], pipaA.linha.getPoints()[3],
					//pipaB.rabiola[0].getX(), pipaB.rabiola[0].getY(), pipaB.rabiola[pipaB.rabiola.length-1].getX(), pipaB.rabiola[pipaB.rabiola.length-1].getY()
					pipaB.rabiola[0].getX(), pipaB.rabiola[0].getY(), pipaB.rabiola[5].getX(), pipaB.rabiola[5].getY()
				);
			}

			if(result2.onLine1 && result2.onLine2){
				
				//console.clear();
				//console.log('colidiu rabiola');

				var tot2 = pipaB.rabiola.length;
				while(tot2--){

					if((tot2 > 1 || pipaB.totFitasRabiola == 1) && tot2 < 7){

						var result3 = checkLineIntersection(
							pipaA.posLine.x, pipaA.posLine.y, pipaA.linha.getPoints()[2], pipaA.linha.getPoints()[3],
							pipaB.rabiola[tot2].getX(), pipaB.rabiola[tot2].getY(), pipaB.rabiola[tot2].getX()+3, pipaB.rabiola[tot2].getY()+3
						);

						if(result3.onLine1 && result3.onLine2){

							var dif = pipaA.linha.getPoints()[3],
							a1 = pipaA.linha.getPoints()[1] - dif,
							a3 = result3.y - dif,
							pct4 = 1 - ((a3 / a1) * 1);
							
						
							if(type == 'online'){
								socket.emit('aparou', {
									sala:sala,
									pipa:pipaA.name,
									pipaAparada:pipaB.name,
									x:result3.x,
									y:result3.y,
									pct:pct4,
									indice:tot2
								});
							}else{
								pipaB.rabiolaColidiu = {
									pipa:pipaA,
									x:result3.x,
									y:result3.y,
									pct:pct4,
									indice:tot2
								}
								pipaA.pipasAparadas.push(pipaB);
								pipaA.aparou();
								if(pipaA.pipaPrincipal) {
									sons.play('aparou');
									setVibrate();
								}
							}
							
							
							
							if(type == "combate") {
								if(pipaA.pipaPrincipal) {

									if(arrStorage.pipas.length == jsonPipas.length){
													
										/*$('body').append(
										'<div id="popup" class="animated zoomInDown">' +
							            '    <div class="tx">' +
							            '        <a class="close"></a>' +
							            '        <h1>' + getHashtag('zerou') + '</h1>' +
							            '    </div>' +
							            '</div>');
							            $('#popup .close').tap(function(){$('#popup').remove();});*/
							            setBalaoZerou();

									}else{
										voltarSelect(12000);
									}
									
								}

							}

							break;

						}

					}

				}

			}

		

			//TESTANDO APARO ===========================
				
			/*if(result3 == null) return;
			if(result3.onLine1 && result3.onLine2){

				//pipaA.setVibrate();

				//===============
				// Calculo PCT ==
				//(($acertos / $perguntas) * 100)


			}*/

		}

	}

}


function checkLineIntersection(line1StartX, line1StartY, line1EndX, line1EndY, line2StartX, line2StartY, line2EndX, line2EndY) {
    
    var a, b, numerator1, numerator2, result = {
        x:null,
        y:null,
        onLine1:false,
        onLine2:false
    },
    denominator = ((line2EndY - line2StartY) * (line1EndX - line1StartX)) - ((line2EndX - line2StartX) * (line1EndY - line1StartY));

    if (denominator != 0) {
	    
	    a = line1StartY - line2StartY;
	    b = line1StartX - line2StartX;
	    numerator1 = ((line2EndX - line2StartX) * a) - ((line2EndY - line2StartY) * b);
	    numerator2 = ((line1EndX - line1StartX) * a) - ((line1EndY - line1StartY) * b);
	    a = numerator1 / denominator;
	    b = numerator2 / denominator;
	    
	    result.x = line1StartX + (a * (line1EndX - line1StartX));
	    result.y = line1StartY + (a * (line1EndY - line1StartY));
	
	    if (a > 0 && a < 1) result.onLine1 = true;
	    if (b > 0 && b < 1) result.onLine2 = true;
	    
	}

	return result;

}

