﻿
function Pipa(){

	this.pipaPrincipal = false;
	this.name = null;
	
	this.infosOnline = {};

	this.velocidade = 3;
	this.morreu = false;
	this.indice = null;
	this.indicePipa = null;
	
	this.arr = null;
	this.pipasAparadas = [];
	this.cont = 0;
	this.timeAction = 0;
	this.timeCorte = 0;

	this.scale = 0.5;
	
	this.acres = 0;
	this.fatiou = -1;
	this.fatiouArr = [];
	
	// ----

	this.fitasRabiola = null;
	this.totFitasRabiola = null;
	
	this.podegirar = 0;
	this.pipagirar = false;

	this.ladoLadoPuxar = 0;

	this.distanceDibique = 10;
	this.ease = null;
	this.poderLine = null;

	this.directionRight = true;//1 = right || -1 = left
	this.animatedLadoAlado = true;
	this.gravidade = 0;
	this.gravidadeRotacao = 0;

	this.posLine = {};
	this.limiteVelocidade = {left:0, right:0, limite:5};

	this.group = null;
	this.linha = null;
	this.argola = null;
	//this.texto = null;
	this.rabiola = [];
	this.rabiolaColidiu = null;
	this.controller = null;

	this.controler = null;

	this.groupX = 0;
	this.groupY = 0;

	this.vibrate = false;
	this.timeout = null;
	this.timeoutvibrate = null;
	this.scalePoint = 0;
	this.pipa = null;
	this.img = null;
	this.line = null;

	var instance = this;
	
	this.init = function(obj){

		clearTimeout(instance.timeout);

		instance.name = obj.name;

		instance.timeCorte = 0;

		if(type == 'online'){
			instance.infosOnline = {
				nick:obj.nick,
				cortou:obj.cortou,
				aparou:obj.aparou,
				voou:obj.voou
			}
		}

		instance.arr = obj.arr;
		instance.poderLine = linhas[obj.line].poder;
		instance.indice = obj.indice;
		instance.indicePipa = obj.indicePipa;
		instance.pipaPrincipal = obj.pipaPrincipal;
		instance.posLine.x = obj.xLine;
		instance.posLine.y = obj.yLine;
		instance.totFitasRabiola = obj.fitasRabiola.length;
		instance.fitasRabiola = obj.fitasRabiola;
		instance.distanceDibique = obj.distanceDibique;
		instance.limiteVelocidade.limite = obj.ladolado;
		instance.ease = obj.ease;
		instance.scale = obj.scale;
		instance.img = obj.img;
		instance.line = obj.line;
		instance.podegirar = obj.podegirar;
		instance.ladoLadoPuxar = obj.ladoLadoPuxar;
		


		//if(type == 'festival'){
			if(instance.arr	!= null) instance.cont = parseInt(Math.random() * instance.arr.length);
		//}

		if(instance.totFitasRabiola == 0) instance.animaLadoLado = instance.animaLadoLado2;
		
		instance.group = new Kinetic.Group({
			x:obj.x,
		    y:obj.y,
		    scaleX:instance.scale,
		    scaleY:instance.scale
		});

		instance.linha = new Kinetic.Line({
		    points:[obj.x, obj.y, obj.xLine, obj.yLine],
		    stroke:linhas[obj.line].cor,
		    strokeWidth:(((/(ipad)/i.test(navigator.userAgent)) ? 0.4 : 0.34))
		});

		
		var sprite = getSprite(obj.img.substr(0,1), obj.img.substr(2));

		//NEW
		var pObj = { /*width:18, height:18, rotation:-150, offset:{x:8, y:8},*/
			crop: {
		        x:sprite.x,
		        y:sprite.y,
		        width:50,
		        height:50
		    },
		    width:18, height:18,
		    offset:{x:8, y:8},
		    rotation:-150
		}
		
		instance.pipa = new Kinetic.Image(pObj);
		instance.group.add(instance.pipa);
		var img = new Image();
		//if(obj.img.split('/').length > 1){
			//img.src = obj.img;
			img.src = sprite.img;
		//}else{
			//img.src = 'img/default/'+obj.img+'.png';
		//}
	   	

	    //img.onload = function(){
	    	instance.pipa.setImage(img);
	    //}


		instance.addRabiola(obj.x, obj.y);
		
		layer.add(instance.group);
		layer.add(instance.linha);



		//Argola
		if(instance.pipaPrincipal){
			instance.argola = new Kinetic.Image({
				width:68, 
				height:68,
				rotation:0,
				offset:{x:32, y:32}
			});
			instance.group.add(instance.argola);
			var img = new Image();
		    img.src = 'img/argola.png';
		    img.onload = function(){
		    	instance.argola.setImage(img);
		    }
		    setTimeout(function(){
		    	if(instance.argola != null){
		    		instance.argola.remove();
		    		instance.argola = null;
		    	}
		    }, 4000);
		}



		instance.controler = new Controller();
    	instance.controler.init(this);
		
	}

	this.addRabiola = function(x, y){

		for(var c = 0;c < instance.totFitasRabiola;c++){

			instance.rabiola[c] = new Kinetic.Rect({
				x:x,
				y:y,
			    width:instance.fitasRabiola[c].w,
			    height:instance.fitasRabiola[c].h,
			    fill:instance.fitasRabiola[c].c
			});
			
			layer.add(instance.rabiola[c]);

		}

	}

	this.update = function(){

		if(!instance.morreu){
			if(instance.timeAction < 2) instance.timeAction++;
			if(instance.timeCorte < 70) {
				instance.timeCorte++;
				/*if(instance.pipaPrincipal){
					console.clear();
					console.log(instance.timeCorte);
					if(instance.timeCorte == 70) console.log('Pode cortar!');
				}*/
			}
		}

		if(type != 'online'){
		
			if(instance.arr != null){
				if(instance.arr[instance.cont] == 1) instance.controler.dibicar();
				else if(instance.arr[instance.cont] == 2) instance.controler.puxar();
				else if(instance.arr[instance.cont] == 3) instance.controler.descarregar();
				if(instance.cont > instance.arr.length) instance.cont = 0;
				instance.cont++;
			}

		}
		
		
		var rotacao = instance.pipa.getRotation() + 135,
		arrRabiola = instance.rabiola;

		instance.groupX = instance.group.getX();
		instance.groupY = instance.group.getY();


		

		if(instance.gravidade != 0){

			//New Pipa Zig Zag Puxão
			if(instance.ladoLadoPuxar != 0){
				if(!instance.animatedLadoAlado){
					if(instance.gravidade > 0){
						rotacao += instance.animaLadoLadoPuxar() * instance.gravidade;
						instance.pipa.setRotation( rotacao - 135 );
					}
				}
			}

			
			instance.groupX -= Math.sin(rotacao*(Math.PI/180)) * -instance.gravidade;
			instance.groupY -= Math.cos(rotacao*(Math.PI/180)) * instance.gravidade;
			
			var obj = instance.verificaExtremos({x:instance.groupX, y:instance.groupY});
			instance.groupX = obj.x;
			instance.groupY = obj.y;

			instance.group.setY(instance.groupY);
			instance.group.setX(instance.groupX);
			
			

			if(!instance.morreu){

				instance.scale = instance.scale + (instance.gravidade * 0.0008);
				
				if(instance.gravidade < 0) instance.scale = instance.scale + (instance.gravidade * 0.005);

				if(instance.scale > 1.5) {
					instance.scale = 1.5;
				}else if(instance.scale < 0.4) instance.scale = 0.4;

			}

			if(instance.morreu && instance.rabiolaColidiu == null) instance.scale = instance.scale - 0.0005;

			instance.group.setScale({x:instance.scale, y:instance.scale});

			///////////////
			// APAROU LEVOU

			if(instance.gravidade > 0){
				var a = instance.pipasAparadas.length;

				while(a--){
					var pipaAparada = instance.pipasAparadas[a];
					if(pipaAparada.rabiolaColidiu != undefined){
						pipaAparada.rabiolaColidiu.pct -= 0.002 * instance.gravidade;
						if(pipaAparada.rabiolaColidiu.pct < 0){

							if(type == 'festival'){
								if(instance.pipaPrincipal) $('#placar .it').eq(1).find('figure').html( parseInt($('#placar .it').eq(1).find('figure').html()) + 1 );
								Storage.updateRecordFestival();
								if(pipas.length > 1) insertPipaFestival(pipaAparada.indice);
							}

							if(instance.pipaPrincipal){
								if(type == 'combate') {
									Storage.insertNewPipa();
									if(balaoCortouTodas == null && balaoZerou == null) voltarSelect();
								}
								
							}

							if(type == 'pipodramos'){
								if(instance.pipaPrincipal) Storage.insertPipaPipodramos(pipaAparada.indicePipa);
								if(pipas.length > 1) insertPipaFestival(pipaAparada.indice);
							}


							//essa aqui q aparou ela q deve mandar o emit
							if(type == 'online'){
								//console.log('#2', instance.pipaPrincipal, instance.name, pipaAparada.name);
								if(instance.pipaPrincipal){
									if(pipasName[pipaAparada.name].morreu){
										socket.emit('reload', pipaAparada.name);
										pipasName[pipaAparada.name].morreu = false;
									}
								}
							}

							//instance.pipasAparadas.splice(a, 1);
							instance.pipasAparadas.splice(a, 1);
							//console.log(instance.pipasAparadas);
							break;

							//if(type == 'online')

						}
					}
				}
			}

		}


		//if(!instance.podeAparar) return;

		/// ========================

		if(instance.rabiolaColidiu == null){

			var _x = Math.sin(rotacao*(Math.PI/180)),
			_y = Math.cos(rotacao*(Math.PI/180));

			instance.linha.setPoints([
				instance.posLine.x, 
				instance.posLine.y, 
				instance.groupX + ( _x * instance.scale ), 
				instance.groupY + ( _y * instance.scale )
			]);

			if(instance.animatedLadoAlado) instance.animaLadoLado();

			// === IMPORTANT
			instance.updateRabiola(arrRabiola, rotacao, instance.groupX, instance.groupY);

		}else{


			//===== Pipa aparada
			if(instance.gravidade != 0) {

				//instance.rabiola.splice(instance.rabiolaColidiu.indice);
				instance.clearTween();
				instance.rabiola.unshift(instance.group);//Inserindo a pipa como um "última Fita"
				instance.pipa.setOffset({x:0, y:0});
				TweenMax.to(instance.pipa, 0.2, {scaleX:1});
				//instance.totFitasRabiola = instance.rabiola.length;
				instance.totFitasRabiola += 1;
				//arrRabiola = instance.rabiola.reverse();

				TweenMax.to(instance.pipa, 1, { 
					rotation:45
				});
				
				TweenMax.to(instance.pipa, ((instance.totFitasRabiola == 1) ? 2.5 : 1.5), {
					ease:Linear.easeNone, 
					repeat:-1,
					bezier:[
						{ rotation:45 + 180, scaleX:-1, scaleY:-1 },
						{ rotation:45 + 360, scaleX:1, scaleY:1 }
					]
				});

			}


			
			instance.gravidade = 0;
			rotacao = instance.rabiolaColidiu.pipa.pipa.getRotation() + 135;
			instance.groupX = instance.rabiolaColidiu.pipa.linha.getPoints()[0] + ( ( instance.rabiolaColidiu.pipa.linha.getPoints()[2] - instance.rabiolaColidiu.pipa.posLine.x ) * instance.rabiolaColidiu.pct);
			instance.groupY = instance.rabiolaColidiu.pipa.linha.getPoints()[1] + ( ( instance.rabiolaColidiu.pipa.linha.getPoints()[3] - instance.rabiolaColidiu.pipa.posLine.y ) * instance.rabiolaColidiu.pct);

			


			//=================================
			//DIVIDINDO RABIOLA EM DOIS PEDAÇOS
			//=================================

			var arr1 = [],
			arr2 = [],
			t;
			for(t = 0;t < instance.rabiolaColidiu.indice;t++) arr1.push(instance.rabiola[t]);
			for(t = instance.rabiolaColidiu.indice;t < instance.totFitasRabiola;t++) arr2.push(instance.rabiola[t]);

			instance.updateRabiola(arr1.reverse(), rotacao, instance.groupX, instance.groupY);
			instance.updateRabiola(arr2, rotacao, instance.groupX-1, instance.groupY+1);

		}

		/// ========================
		/// ========================
		
		
		
		//Update cenario move
		/*if(instance.pipaPrincipal){
			//(80 / 100) * 1 = 0.8 ///calculo PCT
			var a = instance.scale-0.4;
			var scala = (a / 1.1) * 40;
			var quantoPossoMover = (scala / 100) * stageWidth;
			var moveX = (instance.groupX / stageWidth) * quantoPossoMover;
			
			//console.clear();
			//console.log(moveX-quantoPossoMover, moveX,quantoPossoMover);

			$('main').css({backgroundSize:(100 + scala)+'% auto', backgroundPositionX:moveX-quantoPossoMover })
		}*/

	}

	this.updateRabiola = function(arrRabiola, rotacao, x, y){

		var rab_X_Y = {x:null, y:null},
		dif = 12 * instance.scale,
		dif2 = (-16 * instance.scale);


		for (var c = 0, tot3 = arrRabiola.length; c < tot3; c++) {
			
			var itRab = arrRabiola[c];

			var __x, 
			__y,
			posXatual = itRab.getX(),
			posXir = x,
			posYatual = itRab.getY(),
			posYir,
			rot = rotacao;


			
			if(instance.gravidade < 0){
				if(c > 3) rot = 0;
			}
			
			//deixo sem gravidade se tiver dibicando ou puxando
			//if(!instance.animatedLadoAlado) {
				var ___y = Math.abs( Math.sin(rotacao*(Math.PI/360))) * 10;
				if(instance.rabiolaColidiu != null) {
					___y = Math.abs( Math.sin(rotacao*(Math.PI/360))) * 1;
					dif2 = (-1 * instance.scale);
				}

				posYir = y + (c * (8 - ___y));


			//}

			posXir = posXir + (dif2 * Math.sin(rotacao*(Math.PI/180)));
			posYir = posYir - (dif2 * Math.cos(rotacao*(Math.PI/180)));


			if(instance.fatiou != -1){
				
				if(instance.fatiou == c) {
					posXir = posXatual = instance.fatiouArr[0];
					rab_X_Y.x = posXir;
					posYir = instance.fatiouArr[1];
					rab_X_Y.y = posYir;
					rot = 0;
				}else if(instance.fatiou < c){
					instance.fatiouArr[1]+= 0.15 * instance.scale;
					posYir = instance.fatiouArr[1];
					dif = 1.4 * instance.scale;
					//rot = 0;
				}
			}
			

			
			
			if(c == 0){
				__x = posXir;
				__y = posYir;
				//rot = rotacao;
			}else{
				
				__x = getDelay(posXatual, posXir, c * 3.5);
				__y = getDelay(posYatual, posYir, c * 3.5);

				if(__x > rab_X_Y.x + dif) __x = getDelay(__x, rab_X_Y.x + dif, 2);
				else if(__x < rab_X_Y.x - dif) __x = getDelay(__x, rab_X_Y.x - dif, 2);
				
				if(__y > rab_X_Y.y + dif) __y = getDelay(__y, rab_X_Y.y + dif, 2);
				else if(__y < rab_X_Y.y - dif) __y = getDelay(__y, rab_X_Y.y - dif, 2);

				rot = getDelay(itRab.getRotation(), rotacao, c * 3.5);
				if(instance.morreu) rot = getDelay(itRab.getRotation(), rotacao, c * 8.5);

			}


			


			rab_X_Y.x = __x;
			rab_X_Y.y = __y;
			
			itRab.setX(__x);
			itRab.setY(__y);
			itRab.setScale({x:instance.scale, y:instance.scale});
			itRab.setRotation(rot);

		}

	}


	this.verificaExtremos = function(obj){
		var limite = 11 * instance.scale;
		if(instance.morreu){
			if(obj.y > (stageHeight + 60 - limite)) {
				if(type == 'combate') {
					if(balaoCortouTodas == null && balaoZerou == null) voltarSelect();
				}
				if(type == 'festival' || type == 'pipodramos') insertPipaFestival(instance.indice);
				if(type == 'online') {
					//instance.morreu = false;//apenas p/ não enviar emit mais de um vez
					//if(nomePlayer == instance.name) socket.emit('desconectar'+sala, nomePlayer);
					//if(nomePlayer == instance.name) {
						//console.log('#1',instance.name, nomePlayer);
						if(instance.pipaPrincipal){
							socket.emit('reload', nomePlayer);
							instance.morreu = false;
						}
					//}
				}
			}
		}else{
			///return;
			if(obj.x < limite) {
				obj.x = limite;
				//instance.ajustRot();
				instance.animatedLadoAlado = true;
			}
			if(obj.x > stageWidth - limite) {
				obj.x = stageWidth - limite;
				//instance.ajustRot();
				instance.animatedLadoAlado = true;
			}
			if(obj.y < limite) {
				obj.y = limite;
				//instance.ajustRot();
				instance.animatedLadoAlado = true;
			}
			if(obj.y > stageHeight - limite) {
				obj.y = stageHeight - limite;
				//instance.ajustRot();
				instance.animatedLadoAlado = true;
			}
		}
		return obj;
	}

	this.ajustRot = function(){
		var rot = instance.pipa.getRotation();
		var _r = rot + (-135 - rot) * 0.05;
		instance.pipa.setRotation( _r );
	}

	this.getPointX = function(){
		return instance.groupX + ((instance.posLine.x - instance.groupX) * (instance.scalePoint));
	}

	this.getPointY = function(){
		return instance.groupY + ((instance.posLine.y - instance.groupY) * (instance.scalePoint));
	}

	this.animaLadoLadoPuxar = function(){
		
		if(instance.directionRight){
			
			instance.limiteVelocidade.right = instance.limiteVelocidade.right + (instance.limiteVelocidade.limite - instance.limiteVelocidade.right) * 0.1;
			instance.acres = instance.acres + (instance.ladoLadoPuxar - instance.acres) * 0.4;
			
			instance.velocidade += instance.acres;
			if(instance.velocidade > instance.limiteVelocidade.right) {
				instance.directionRight = !instance.directionRight;
				instance.velocidade = instance.limiteVelocidade.right;
			}
			
		}else{
			
			instance.limiteVelocidade.left = instance.limiteVelocidade.left + (instance.limiteVelocidade.limite - instance.limiteVelocidade.left) * 0.1;
			instance.acres = instance.acres + (-(instance.ladoLadoPuxar) - instance.acres) * 0.4;
			
			instance.velocidade += instance.acres;
			if(instance.velocidade < -(instance.limiteVelocidade.left)){
				instance.directionRight = !instance.directionRight;
				instance.velocidade = -(instance.limiteVelocidade.left);
			}

		}

		return instance.acres;

	}

	this.animaLadoLado = function(){

		if(instance.pipagirar){
			if(instance.gravidade < 0){
				instance.animaLadoLado2();
				return;
			}
		}
		
		if(instance.directionRight){
			
			instance.limiteVelocidade.right = instance.limiteVelocidade.right + (instance.limiteVelocidade.limite - instance.limiteVelocidade.right) * 0.1;
			instance.acres = instance.acres + (2 - instance.acres) * 0.2;
			
			instance.velocidade += instance.acres;
			if(instance.velocidade > instance.limiteVelocidade.right) {
				instance.directionRight = !instance.directionRight;
				instance.velocidade = instance.limiteVelocidade.right;
			}
			
		}else{
			
			instance.limiteVelocidade.left = instance.limiteVelocidade.left + (instance.limiteVelocidade.limite - instance.limiteVelocidade.left) * 0.1;
			instance.acres = instance.acres + (-2 - instance.acres) * 0.2;
			
			instance.velocidade += instance.acres;
			if(instance.velocidade < -(instance.limiteVelocidade.left)){
				instance.directionRight = !instance.directionRight;
				instance.velocidade = -(instance.limiteVelocidade.left);
			}

		}
		
		var pipaX = instance.group.getX(),
		_XA = pipaX + (instance.velocidade * 5),
		_x = pipaX + (_XA - pipaX) * 0.1,

		rot = instance.pipa.getRotation() + 135,
		_RA = (instance.velocidade * 7);


		//Resolve Bug rotacao
		/*if(rot > 180) rot -= 360;
		if(rot < -180) rot += 360;*/
		
		var _r = rot + (_RA - rot) * 0.1;

		instance.group.setX( _x );
		instance.pipa.setRotation( _r - 135 );

	}

	this.animaLadoLado2 = function(){

		instance.groupX = instance.group.getX();
		instance.groupY = instance.group.getY();
		
		var rotacao = instance.pipa.getRotation() + 135;
		if(rotacao >= 360) rotacao = 0;
		if(rotacao <= -360) rotacao = 0;
		
		if(instance.directionRight){
			
			instance.gravidadeRotacao = instance.gravidadeRotacao + (2 - instance.gravidadeRotacao) * 0.9;
			instance.groupX -= Math.sin(rotacao*(Math.PI/180)) * -(instance.gravidadeRotacao * (3 * instance.scale));
			if(instance.gravidade < 0){
				instance.groupY -= Math.cos(rotacao*(Math.PI/180)) * (instance.gravidadeRotacao);
				if(instance.pipagirar){
					rotacao += 12;
				}else{
					rotacao += 6;	
				}
			}
			
			rotacao += 4;
			if(rotacao > 35 && instance.directionRight && instance.gravidade >= 0) instance.directionRight = false;

		}else{

			instance.gravidadeRotacao = instance.gravidadeRotacao + (-2 - instance.gravidadeRotacao) * 0.9;
			instance.groupX -= Math.sin(rotacao*(Math.PI/180)) * (instance.gravidadeRotacao * (3 * instance.scale));
			if(instance.gravidade < 0){
				instance.groupY -= Math.cos(rotacao*(Math.PI/180)) * -(instance.gravidadeRotacao);
				if(instance.pipagirar){
					rotacao -= 12;
				}else{
					rotacao -= 6;	
				}
			}
			
			rotacao -= 4;
			if(rotacao < -35 && !instance.directionRight && instance.gravidade >= 0) instance.directionRight = true;

		}
		
		if(Math.abs(rotacao) > 45 && Math.abs(rotacao) < 315) instance.groupY += 2 * instance.scale;

		//if(type != 'online'){
			var obj = instance.verificaExtremos({x:instance.groupX, y:instance.groupY});
			instance.groupX = obj.x;
			instance.groupY = obj.y;
		//}

		instance.group.setY(instance.groupY);
		instance.group.setX(instance.groupX);
		instance.pipa.setRotation(rotacao - 135);

	}

	this.clearTween = function(){
		TweenMax.killTweensOf(instance.group);
		TweenMax.killTweensOf(instance.pipa);
	}

	this.aparou = function(result){

		//===========================
		//Add sua nova Pipa
		if(type != 'online'){
			if(instance.pipaPrincipal && instance.pipasAparadas.length >= 3) setBalao2(5);
		}

		//console.log('INSERIR SOM, PUXA PUXA');

		//if(instance.pipaPrincipal) Storage.insertNewPipa();

	}

	this.setMorreu = function(pipaCortou, x, y){
		
		var pipaPai = (type == 'online' && nomePlayer) ? pipasName[pipaCortou] : pipaCortou;
		//===========================
		//Add Fase seguinte
		if(type == 'combate'){

			if(!instance.pipaPrincipal){
				Storage.insertNextFase();
			}else{
				Storage.removePipaUsage();

				if(arrStorage.pipas.length == 0){
					setTimeout(function(){
						close();
						$('#select').removeClass().css({display:'block'});
						$('#select nav').removeClass().css({display:'block'}).addClass('animated zoomInUp');;
						$('#select aside').removeClass().hide();
					}, 5000);
				}

			}

		}

		if(instance.pipaPrincipal){
			
			if(type == "festival" || type == "pipodramos"){
				setMsg('GAME OVER', stageWidth / 2, stageHeight / 2, 3000, 30);
				voltarSelect(6000);
			}else if(type == "combate"){
				//console.log(arrStorage.pipas.length)
				if(arrStorage.pipas.length == 0){
					setMsg('GAME OVER', stageWidth / 2, stageHeight / 2, 3000, 30);
				}else{
					//setMsg('- 1 '+getHashtag('cortou').toUpperCase(), result.x, result.y, 600, 21);
					voltarSelect(6000);
				}
			}else if(type == 'pipodramos'){
				Storage.removePipaPipodramos(instance.indicePipa);
				voltarSelect(3000);
			}

		}

		

		//===========================
		
					
		//console.log('outro');
		instance.morreu = true;
		instance.timeCorte = 0;
		//instance.posLine.x = result.x;
		//instance.posLine.y = result.y;
		
		instance.linha.setOpacity(0);

		if(instance.controler.timeout) clearTimeout(instance.controler.timeout);

		instance.effPipaCaindo();

		if(instance.totFitasRabiola == 0){
			instance.totFitasRabiola = 1;
			instance.fitasRabiola = [{c:"",w:0,h:5}];
			instance.addRabiola(instance.group.getX(), instance.group.getY());
		}

		// **** Clear Pipas Aparadas
		instance.clearPipasAparadas();

		//effCrop
		var a = new Kinetic.Image({
			x:x,
			y:y,
			width:21,
			height:15,
			offset:{x:10, y:7}
		});
		layer.add(a);
		var img = new Image();
	    img.src = ((pipaPai.pipaPrincipal) ? 'img/+1.png' : 'img/+1r.png');
	    img.onload = function(){ a.setImage(img); }
		TweenMax.to(a, 0.5, { delay:0.6, y:"-=14", opacity:0, onCompleteParams:[a], onComplete:function(a){
			a.remove();
			delete a;
		} });

	}

	this.fatiarPipa = function(indice){
		var obj = instance.pipasAparadas[indice];
		if(obj != undefined){
			if(obj.rabiola[0].nodeType == 'Group'){
				
				if(obj.totFitasRabiola > 3){
					
					var m = obj.totFitasRabiola-1;
					if(m > 6) m = 6;
					obj.fatiou = obj.rabiolaColidiu.indice - 1;
					obj.fatiouArr = [ obj.rabiola[obj.fatiou].getX(), obj.rabiola[m].getY() ];

					if(instance.pipaPrincipal) playSom('fatiou', 1);

					//effCrop
					var a = new Kinetic.Image({
						x:obj.fatiouArr[0],
						y:obj.fatiouArr[1],
						width:21,
						height:15,
						offset:{x:10, y:7}
					});
					layer.add(a);
					var img = new Image();
				    img.src = 'img/+1.png';
				    img.onload = function(){ a.setImage(img); }
					TweenMax.to(a, 0.5, { delay:0.6, y:"-=14", opacity:0, onCompleteParams:[a], onComplete:function(a){
						a.remove();
						delete a;
					} });

				}

				if(obj.controler && obj.controler.timeout != null) clearTimeout(obj.controler.timeout);
				obj.clearTween();
				obj.rabiolaColidiu = null;
				obj.pipa.setOffset({x:7, y:7});
				obj.pipa.setScaleX(1);
				obj.pipa.setScaleY(1);
				obj.pipa.setRotation(45);
				obj.rabiola.splice(0, 1);
				obj.totFitasRabiola = obj.rabiola.length;
				obj.effPipaCaindo();

				instance.pipasAparadas.splice(indice, 1);

			}
		}

	}

	this.clearPipasAparadas = function(fatiou){
		var a = instance.pipasAparadas.length;
		while(a--){
			var obj = instance.pipasAparadas[a];
			if(obj.rabiola[0].nodeType == 'Group'){
				if(obj.controler && obj.controler.timeout != null) clearTimeout(obj.controler.timeout);
				obj.clearTween();
				obj.rabiolaColidiu = null;
				obj.pipa.setOffset({x:7, y:7});
				obj.pipa.setScaleX(1);
				obj.pipa.setScaleY(1);
				obj.pipa.setRotation(45);
				obj.rabiola.splice(0, 1);
				obj.totFitasRabiola = obj.rabiola.length;
				obj.effPipaCaindo();
			}
		}
		instance.pipasAparadas = [];
	}

	this.effPipaCaindo = function(){

		instance.animatedLadoAlado = false;
		instance.gravidade = 2;//1.0;
		instance.clearTween();

		instance.setEffPipaCaindo(instance.pipa);

	}

	this.setEffPipaCaindo = function(obj){

		TweenMax.to(obj, 0.25, { 
			immediateRender:true,
			rotation:45,
			ease:instance.ease
		});

		var arrBezier;

		if(type != 'online'){
			arrBezier = [
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) },
				{ scaleX:rand(-0.2, 1), rotation:45 + rand(-80, 80) }
			];
		}else{
			arrBezier = [{scaleX:0.8,rotation:34},{scaleX:-0.2,rotation:97},{scaleX:0.8,rotation:50},{scaleX:-0.2,rotation:57},{scaleX:0.8,rotation:86},{scaleX:0.8,rotation:45},{scaleX:1.8,rotation:42},{scaleX:0.8,rotation:29},{scaleX:-0.2,rotation:72},{scaleX:-0.2,rotation:-30},{scaleX:0.8,rotation:34},{scaleX:0.8,rotation:15},{scaleX:-0.2,rotation:94},{scaleX:0.8,rotation:59},{scaleX:-0.2,rotation:88},{scaleX:1.8,rotation:20},{scaleX:-0.2,rotation:125},{scaleX:-0.2,rotation:51},{scaleX:0.8,rotation:34},{scaleX:0.8,rotation:98},{scaleX:1.8,rotation:95},{scaleX:1.8,rotation:55},{scaleX:0.8,rotation:5},{scaleX:0.8,rotation:114},{scaleX:0.8,rotation:-18},{scaleX:-0.2,rotation:21},{scaleX:0.8,rotation:119},{scaleX:1.8,rotation:87},{scaleX:0.8,rotation:-18},{scaleX:0.8,rotation:86},{scaleX:1.8,rotation:-29},{scaleX:-0.2,rotation:38},{scaleX:-0.2,rotation:50},{scaleX:-0.2,rotation:5},{scaleX:0.8,rotation:55},{scaleX:-0.2,rotation:38},{scaleX:0.8,rotation:35},{scaleX:0.8,rotation:34},{scaleX:0.8,rotation:27}]
		}

		TweenMax.to(obj, 25, {delay:0.25, bezier:arrBezier, ease:Linear.easeNone});

	}

	this.close = function(){
		clearTimeout(instance.timeout);
		if(instance.controler != undefined){
			instance.controler.close();
			delete instance.controler;
		}

		// **** Clear Pipas Aparadas
		instance.clearPipasAparadas();

		//var a = instance.pipasAparadas.length;
		//while(a--) instance.pipasAparadas[a].remove();
		var a = instance.rabiola.length;
		while(a--) instance.rabiola[a].remove();
		
		instance.pipa.remove();
		instance.linha.remove();
		instance.group.remove();

	}

}